'\"     # CS - begin code section
.de CS
.RS 4
\fC
.ps -1
.nf
.sp
..
'\"     # CE - end code section
.de CE
.fi
\fR
.ps +1
.RE
.sp .5
..
.TH archive 3C "TACOMA 1.1" "C primitives"
.SH NAME
archive \- archive a briefcase
.sp
unarchive \- un-archive a briefcase
.SH SYNOPSIS
\fC#include <tacoma.h>\fR
.PP
\fCbriefcase unarchive(briefcase bc, char *archive);\fR
.PP
\fCchar *archive(briefcase bc);\fR
.SH DESCRIPTION
\fCarchive()\fR packs the passed briefcase
.I bc
and returns it in the form of a string (currently a Tcl list). It is
the responsibility of the caller the deallocate this string. 

\fCunarchive()\fR unpacks the passed
.I archive
into the supplied briefcase
.I bc
which is also returned.
Since \fCunarchive()\fR only adds/overwrites folders found  in  the
archive  to  the  supplied \fIbriefcase\fR this briefcase doesn't need to be
empty. However, folders existing in both  the  briefcase  and  archive
will be overwritten in the briefcase.

These two functions are the inverse of each other so
.CS
unarchive(my_bc, archive(my_bc));
.CE
will have no effect.
.SH "RETURN VALUE"
\fCarchive()\fR returns the packed briefcase as a string, or NULL if
an error occurred.
\fCunarchive()\fR returns the passed briefcase or NULL if an error
occurred.
.SH BUGS
These functions are still unreliable when used on data which contains an
unbalanced number of curly brackets.
.SH AUTHOR
Kjell Irgens (kjelli@stud.cs.uit.no), Magne Rasmussen
(magner@stud.cs.uit.no) and Nils Peter Sudmann (nilss@stud.cs.uit.no), University of
Tromsoe.
Concept by Dag Johansen (dag@cs.uit.no), Robbert van Renesse
(rvr@cs.cornell.edu) and Fred B. Schneider (fbs@cs.cornell.edu).
