.TH bc_create 3 "TACOMA 1.1" "C primitives"
.SH NAME
bc_create \- creates a new local briefcase
.sp
bc_discard \- deletes a local briefcase
.sp
bc_list \- list the folders of a local briefcase
.SH SYNOPSIS
\fC#include <tacoma.h>\fR
.PP
\fCbriefcase bc_create(void);\fR
.PP
\fCvoid bc_discard(briefcase bc);\fR
.PP
\fCchar **bc_list(briefcase bc);\fR
.SH DESCRIPTION
\fCbc_create()\fR
creates and initializes a new local briefcase.
Briefcases must be created using this command before accessing
them, and should be deallocated by 
.IR bc_discard (3C) 
once they are no longer needed.
Briefcases are not persistent (unlike the previous implementation of
TACOMA based on UNIX shell). To achieve persistent briefcases one has to use
cabinets, see 
.IR cabinet_create (3C).

\fCbc_discard()\fR deletes the briefcase
.I bc
and all folders associated with it.

\fCbc_list()\fR
creates a list of all folders in the briefcase
.I bc.
It returns this list as a NULL-terminated array of strings that each
represents the name of a folder in the briefcase. It is the
responsibility of the caller to 
free this array and the strings in it. For this, \fCtacoma.h\fR
defines a macro called \fCfree_copy(char **)\fR which does exactly
this.

.SH "RETURN VALUE"
\fCbc_create()\fR
returns an allocated briefcase (or NULL in case of an error).
\fCbc_list()\fR returns a NULL-terminated array of strings or NULL if an error has occurred.
.SH SEE ALSO
.IR folder_fetch (3C), archive (3C), folder_shift (3C)
.SH AUTHOR
Kjell Irgens (kjelli@stud.cs.uit.no), Magne Rasmussen
(magner@stud.cs.uit.no)
and Nils Peter Sudmann (nilss@stud.cs.uit.no), University of
Tromsoe. 
Concept by Dag Johansen (dag@cs.uit.no), Robbert van Renesse
(rvr@cs.cornell.edu) and Fred B. Schneider (fbs@cs.cornell.edu).
