/*******************************************************************************
 *
 * $Source: /users/studenter/nilss/source/RCS/tac_meet.c,v $
 * $Header: tac_meet.c,v 1.3 96/02/29 13:45:08 nilss Exp $
 * $Author: nilss $
 * $Date: 96/02/29 13:45:08 $
 * Language: C
 * Status: Experimental
 *
 * (c) Copyright 1996, TACOMA, all rights reserved.
 *
 ******************************************************************************/
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include "tacoma.h"
#include "meet.h"


int
main( int argc, char* argv[] )
{
    int	       flags;
    int	       result;
    string     arc;
    briefcase  bc;

    /* check correct invocation */
    if ( (argc < 2) || (argc > 3) ) {
	fprintf(stderr, "\nUsage: %s <agent> [flag]\n\n", argv[0]);
	return (10);
    }

    /* check and set flags */
    if ( argc > 2 ) {
	if ( !isdigit(*argv[2]) ) {
	    fprintf(stderr, "Flags must be decimal value.\n");
	    return (10);
	}
	else
	    flags = atoi(argv[2]);
    }
    else
	flags = 0;

    /* read archive from stdin and create briefcase */
    arc = tac_read_bc_stream(0);
    bc = bc_create();
    unarchive(bc, arc);
    free(arc);

    /* meet with contact */
    result = meet(argv[1], bc, flags);

    /* write modified briefcase to stdout */
    tac_write_bc_stream(1, bc);

    /* return result */
    return (result);
}
