
#ifndef TACOMA_ELK_H
#define TACOMA_ELK_H

#include "scheme.h"
#include "tacoma.h"

/*
 *   Definitions for the briefcase-object.
 */
struct s_briefcase {
    Object 	unused;
    briefcase	bc;
};

extern int T_Briefcase;

#define BRIEFCASE(obj)	((struct s_briefcase *)POINTER(obj))


/*
 *   Definitions for the cabinet-object.
 */
struct s_cabinet {
    Object 	unused;
    char        *name;
    cabinet     cab;
    int         closed;
};

extern int T_Cabinet;

#define CABINET(obj)	((struct s_cabinet *)POINTER(obj))



/*
 *   Function definitions.
 */
Object make_strlist(char **);
briefcase Get_Briefcase( Object );
cabinet Get_Cabinet( Object );

/*
 *   Primitives
 */
Object P_Briefcasep( Object );
Object P_Bc_Create();
Object P_Bc_Discard( Object );
Object P_Bc_List( Object );
Object P_Archive( Object );
Object P_Unarchive( Object, Object );
Object P_Folder_Store( int, Object* );
Object P_Folder_Fetch( Object, Object );
Object P_Folder_Delete( Object, Object );
Object P_Folder_Shift( int, Object* );
Object P_Folder_Rotate( Object, Object, Object, Object );


#endif /* TACOMA_ELK_H */
