################################################################################
#
# $Source: /users/studenter/nilss/source/RCS/extensions.tcl,v $
# $Header: extensions.tcl,v 1.8 96/02/29 13:39:51 nilss Exp $
# $Author: nilss $
# $Date: 96/02/29 13:39:51 $
# Language: Tcl
# Status: Experimental
#
# (c) Copyright 1996, TACOMA, all rights reserved.
#
################################################################################
proc folder_append {bc foldername contents} {
    upvar $bc loc_bc
    append loc_bc($foldername) $contents
}

proc folder_add {bc foldername contents} {
    upvar $bc loc_bc
    folder_shift loc_bc $foldername left 0 $contents
}

proc folder_push {bc foldername contents} {
    upvar $bc loc_bc
    folder_shift loc_bc $foldername right 0 $contents
} 

proc folder_pop {bc foldername} {
    upvar $bc loc_bc
    return [folder_shift loc_bc $foldername left 1]
}

proc folder_top {bc foldername} {
    upvar $bc loc_bc
    return [folder_shift loc_bc $foldername left 0]
}

proc folder_rotate {bc foldername {dir left} {num 1}} {
    upvar $bc loc_bc
    if { [expr {$dir != "left"}] && [expr {$dir != "right"}] } {
	error "illegal direction for rotate"
    }
    if { $num < 0 } {
	if { $dir == "left"} {
	    set dir "right"
	} else {
	    set dir "left"
	}
	set num [expr -$num]
    } 
    if { ![info exists loc_bc($foldername)] } {
	return ""
    }
    if { $num > [llength $loc_bc($foldername)] } {
	set num [expr $num%[llength $loc_bc($foldername)]]
    }
    if { $dir == "left" } {
	set ret [lindex $loc_bc($foldername) [expr $num-1]]
    } else {
	set num [expr [llength $loc_bc($foldername)] - $num]
	set ret [lindex $loc_bc($foldername) $num]
    }
    set right_split [lrange $loc_bc($foldername) $num [llength $loc_bc($foldername)]]
    set left_split [lrange $loc_bc($foldername) 0 [expr $num -1]]
    set loc_bc($foldername) [concat $right_split $left_split] 
    set loc_bc(*\#$foldername) "1"
    return $ret
}

proc folder_shift {bc foldername {dir left} {num 1} args} {
    upvar $bc loc_bc
    if { [expr {$dir != "left"}] && [expr {$dir != "right"}] } {
	error "illegal direction for shift"
    }
    if { $num < 0 } {
	if { $dir == "left"} {
	    set dir "right"
	} else {
	    set dir "left"
	}
	set num [expr -$num]
    }
    if { ![info exists loc_bc($foldername)] } {
	set loc_bc($foldername) $args
	return ""
    }
    if { $dir == "left" } {
	if { $num == 0 } {
	    set ret [lindex $loc_bc($foldername) $num]
	} else {
	    set ret [lindex $loc_bc($foldername) [expr $num-1]]
	}

	set right_split [lrange $loc_bc($foldername) $num [llength $loc_bc($foldername)]] 
	set loc_bc($foldername) [concat $right_split $args]
    } else {
	set rum [expr [llength $loc_bc($foldername)] - $num]
	if { $num == 0 } {
	    set ret [lindex $loc_bc($foldername) [expr $rum-1]]
	} else {
	    set ret [lindex $loc_bc($foldername) $rum]
	}
	set left_split [lrange $loc_bc($foldername) 0 [expr $rum -1]]
	set loc_bc($foldername) [concat $args $left_split]
    }
    if ("$loc_bc($foldername)"=="") {
	unset loc_bc($foldername)
    } else {
	set loc_bc(*\#$foldername) "1"
    }
    return $ret
}







