'\"
'\" Copyright (c) 1990 The Regents of the University of California.
'\" All rights reserved.
'\"
'\" Permission is hereby granted, without written agreement and without
'\" license or royalty fees, to use, copy, modify, and distribute this
'\" documentation for any purpose, provided that the above copyright
'\" notice and the following two paragraphs appear in all copies.
'\"
'\" IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
'\" FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
'\" ARISING OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
'\" CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'\"
'\" THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
'\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
'\" AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
'\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
'\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
'\" 
.\" The definitions below are for supplemental macros used in Tcl/Tk
.\" manual entries.
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'\"	# Heading for Tcl/Tk man pages
.de HS
.ds ^3 \\0
.if !"\\$3"" .ds ^3 \\$3
.if '\\$2'cmds'       .TH \\$1 1 \\*(^3 \\$4
.if '\\$2'lib'        .TH \\$1 3 \\*(^3 \\$4
.if '\\$2'tacoma'         .TH \\$1 n \\*(^3 "TACOMA 1.1" "Tcl Primitives"
.if '\\$2'tacomae'         .TH \\$1 n \\*(^3 TACOMA "TACOMA Extensions"
.if '\\$2'tacomaag'         .TH \\$1 1 \\*(^3 TACOMA "TACOMA Agents"
.if '\\$2'tcldpintro'         .TH \\$1 n \\*(^3 TACOMA "Introduction to TACOMA"
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp .5
..
.HS folder_shift tacomae
.BS
.SH NAME
folder_append \- append data to a folder
.sp
folder_shift \- shift the elements of a folder list
.sp
folder_rotate \- rotate the elements of a folder list
.sp
folder_pop \- retrieves the first element from a folder list
.sp
folder_add \- add a element to the end of a folder list
.sp
folder_push \- add a element to the start of a folder list
.sp
folder_top \- reads the element a folder list
.SH SYNOPSIS
\fBfolder_append \fIbriefcase folder data\fR
.br
\fBfolder_shift \fIbriefcase folder direction amount\fR ?\fIdata1 data2 data3 ...\fR?
.br
\fBfolder_rotate \fIbriefcase folder direction amount\fR
.br
\fBfolder_pop \fIbriefcase folder\fR
.br
\fBfolder_add \fIbriefcase folder data\fR
.br
\fBfolder_push \fIbriefcase folder data\fR
.br
\fBfolder_top \fIbriefcase folder\fR
.BE
.SH DESCRIPTION
The folder_append command appends some information to a \fIfolder\fR. It will
either append the given data to already existing data, or create a new
\fIfolder\fR with the supplied data if the
\fIfolder\fR does not exist.
This is not the same as a folder_add because this function does not preserve
the right list structure as needed by folder_pop. It is however useful
for building a \fIfolder\fR by putting together several other \fIfolder\fRs and
creating and maintaining log \fIfolder\fRs.
.SS Important
All of the commands described below only work with \fIfolder\fRs
where the data is ordered as elements in a list. Using these commands on
\fIfolder\fRs without this ordering will have undocumented side
effects. In the TACOMA system the first element (or top if you think
about them as stacks) is the leftmost element of the
list. Consequently, the last element (or bottom in the case of stacks)
is the rightmost element. This affects all lists used by the system. Private
\fIfolder\fRs may follow any application programmer convention.

The folder_shift command shifts the elements of a \fIfolder\fR in one of two
\fIdirection\fRs, either left or right. A shift removes a number of
elements equal to the \fIamount\fR given from the list. In the case of
a left shift, elements will be removed from the beginning of the
list. In the case of a right shift, elements will be removed from the
end of the list. The last element to be removed is the result of this
function, all other elements removed are lost. 

If the optional \fIdata\fR
elements are supplied, they will be added to the list from the
opposite \fIdirection\fR. The \fIdata\fR will be added to the
\fIfolder\fR in the same order as they appear on the command line. So,
if the \fIdirection\fR of the shift is right, the rightmost element of
the \fIdata\fR is added first. If the \fIdirection\fR is left,
the leftmost \fIdata\fR is added first. 

If the \fIamount\fR to be
shifted is a negative number, the direction changes from left to right
or right to left. If the \fIamount\fR to be shifted is zero, no shift is
performed. The function will return the current leftmost or rightmost
element. If the folder does not exist, folder_shift will create a new
folder if any \fIdata\fR is supplied. It will do nothing if no \fIdata\fR
is supplied. In any case, it will return an empty element if the folder
does not exist. 

The folder_rotate command rotates the elements of a \fIfolder\fR in one of
two \fIdirection\fRs, either left or right. A number of elements equal
to the \fIamount\fR given will be rotated. A rotation will move
elements from the left or the right end of a list to the other
end. The last element to be rotated is the result of this function.
No elements are lost in the rotation. If the \fIamount\fR to be rotated
is a negative number, the direction changes from left to right or
right to left. If the \fIamount\fR to rotated is zero, no rotation is
performed and the function returns a empty element. If the folder does not
exist this command returns the empty element.
.SS Stub routines
The following commands are simple stub routines for the folder_shift command.
They are kept because their syntax is more intuitive than the folder_shift
command. If you feel confident in your understanding of the
folder_shift, command you should use the mappings directly. They are
as follows: 

.RS
folder_pop ... = folder_shift ... left 1
.br
folder_add ... data = folder_shift ... left 0 data
.br
folder_push ... data = folder_shift ... right 0 data
.br
folder_top ... = folder_shift ... left 0
.RE

The folder_pop command retrieves the first element from a \fIfolder\fR
list. It will also remove this element from the \fIfolder\fR list. If
the \fIfolder\fR becomes empty, it is deleted.

The folder_add command adds an element to the end of a \fIfolder\fR
list. It will
either add the given data as a single element to already existing
elements of the \fIfolder\fR, or create a new \fIfolder\fR
with the supplied data as a single element if the \fIfolder\fR does not
exist.
By using this function and folder_pop, one can implement queues
(FIFO) using a single \fIfolder\fR. This function enforces a proper list
structure on the added data (unlike folder_append).

The folder_push adds an element to the start of a \fIfolder\fR list. It will
either add the given data as a single element to already existing
elements of the \fIfolder\fR, or create a new \fIfolder\fR with the supplied data
as a single element if the \fIfolder\fR does not exist.
By using this function and folder_pop one, can implement stacks
(LIFO) using a single \fIfolder\fR.

The folder_top reads the first element from a \fIfolder\fR list. Unlike
folder_pop, it will \fBnot\fR remove this item from the \fIfolder\fR.
.SH EXAMPLE
The following example tries to illuminate the differences and uses of the
various commands discussed above. This example actually mixes common raw
format \fIfolder\fRs with the new list structure introduced above. This is \fBnot\fR
a recommended approach, it is used here to show the difference between folder_add
and folder_append.
.DS
folder_append my_bc MESSAGE "Hello world! "
folder_append my_bc MESSAGE "Read this message:"
puts [folder_fetch my_bc MESSAGE]
folder_add my_bc MESSAGE "Neckties"
folder_add my_bc MESSAGE "strangle clear thinking."
puts [folder_fetch my_bc MESSAGE]
puts [folder_pop my_bc MESSAGE]
puts [folder_pop my_bc MESSAGE]
puts [folder_rotate my_bc MESSAGE left 2]
folder_push my_bc MESSAGE "very important"
puts [folder_fetch my_bc MESSAGE]
puts [folder_shift my_bc MESSAGE right 3 "A"]
folder_add my_bc MESSAGE "are a nice piece of clothing."
puts [folder_fetch my_bc MESSAGE]
.DE

Running this example gives this output (each line matches one puts
statement of the program):

.RS
Hello world! Read this message:
.sp
Hello world! Read this message: Neckties {strangle clear thinking.}
.sp
Hello
.sp
world!
.sp
this
.sp
{very important!} message: Neckties {strangle clear thinking.} Read this
.sp
strangle clear thinking.
.sp
A {very important!} message: Neckties {are a nice piece of clothing.}
.RE

.SH SEE ALSO
folder_store(n), bc_create(n)

.SH AUTHOR
Nils Peter Sudmann, University of Tromsoe (nilss@stud.cs.uit.no)
Concept by Dag Johansen (dag@cs.uit.no), Robbert van Renesse
(rvr@cs.cornell.edu) and Fred B. Schneider (fbs@cs.cornell.edu).
